Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LeafBase.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LeafBase.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LeafBase.cs	(revision 16892)
@@ -0,0 +1,167 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Data;
+using HeuristicLab.Parameters;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("F3A9CCD4-975F-4F55-BE24-3A3E932591F6")]
+  public abstract class LeafBase : ParameterizedNamedItem, ILeafModel {
+    public const string LeafBuildingStateVariableName = "LeafBuildingState";
+    public const string UseDampeningParameterName = "UseDampening";
+    public const string DampeningParameterName = "DampeningStrength";
+
+    public IFixedValueParameter<DoubleValue> DampeningParameter {
+      get { return (IFixedValueParameter<DoubleValue>)Parameters[DampeningParameterName]; }
+    }
+    public IFixedValueParameter<BoolValue> UseDampeningParameter {
+      get { return (IFixedValueParameter<BoolValue>)Parameters[UseDampeningParameterName]; }
+    }
+
+    public bool UseDampening {
+      get { return UseDampeningParameter.Value.Value; }
+      set { UseDampeningParameter.Value.Value = value; }
+    }
+    public double Dampening {
+      get { return DampeningParameter.Value.Value; }
+      set { DampeningParameter.Value.Value = value; }
+    }
+
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected LeafBase(StorableConstructorFlag _) : base(_) { }
+    protected LeafBase(LeafBase original, Cloner cloner) : base(original, cloner) { }
+    protected LeafBase() {
+      Parameters.Add(new FixedValueParameter<BoolValue>(UseDampeningParameterName, "Whether logistic dampening should be used to prevent extreme extrapolation (default=false)", new BoolValue(false)));
+      Parameters.Add(new FixedValueParameter<DoubleValue>(DampeningParameterName, "Determines the strength of logistic dampening. Must be > 0.0. Larger numbers lead to more conservative predictions. (default=1.5)", new DoubleValue(1.5)));
+    }
+    #endregion
+
+    #region IModelType
+    public abstract bool ProvidesConfidence { get; }
+    public abstract int MinLeafSize(IRegressionProblemData pd);
+
+    public void Initialize(IScope states) {
+      states.Variables.Add(new Variable(LeafBuildingStateVariableName, new LeafBuildingState()));
+    }
+
+    public void Build(RegressionNodeTreeModel tree, IReadOnlyList<int> trainingRows, IScope stateScope, CancellationToken cancellationToken) {
+      var parameters = (RegressionTreeParameters)stateScope.Variables[M5Regression.RegressionTreeParameterVariableName].Value;
+      var state = (LeafBuildingState)stateScope.Variables[LeafBuildingStateVariableName].Value;
+
+      if (state.Code == 0) {
+        state.FillLeafs(tree, trainingRows, parameters.Data);
+        state.Code = 1;
+      }
+      while (state.nodeQueue.Count != 0) {
+        var n = state.nodeQueue.Peek();
+        var t = state.trainingRowsQueue.Peek();
+        int numP;
+        n.SetLeafModel(BuildModel(t, parameters, cancellationToken, out numP));
+        state.nodeQueue.Dequeue();
+        state.trainingRowsQueue.Dequeue();
+      }
+    }
+
+    public IRegressionModel BuildModel(IReadOnlyList<int> rows, RegressionTreeParameters parameters, CancellationToken cancellation, out int numberOfParameters) {
+      var reducedData = RegressionTreeUtilities.ReduceDataset(parameters.Data, rows, parameters.AllowedInputVariables.ToArray(), parameters.TargetVariable);
+      var pd = new RegressionProblemData(reducedData, parameters.AllowedInputVariables.ToArray(), parameters.TargetVariable);
+      pd.TrainingPartition.Start = 0;
+      pd.TrainingPartition.End = pd.TestPartition.Start = pd.TestPartition.End = reducedData.Rows;
+
+      int numP;
+      var model = Build(pd, parameters.Random, cancellation, out numP);
+      if (UseDampening && Dampening > 0.0) {
+        model = DampenedModel.DampenModel(model, pd, Dampening);
+      }
+
+      numberOfParameters = numP;
+      cancellation.ThrowIfCancellationRequested();
+      return model;
+    }
+
+    public abstract IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters);
+    #endregion
+
+    [StorableType("495243C0-6C15-4328-B30D-FFBFA0F54DCB")]
+    public class LeafBuildingState : Item {
+      [Storable]
+      public Queue<RegressionNodeModel> nodeQueue = new Queue<RegressionNodeModel>();
+      [Storable]
+      public Queue<IReadOnlyList<int>> trainingRowsQueue = new Queue<IReadOnlyList<int>>();
+
+      //State.Code values denote the current action (for pausing)
+      //0...nothing has been done;
+      //1...building models;
+      [Storable]
+      public int Code = 0;
+
+      #region HLConstructors & Cloning
+      [StorableConstructor]
+      protected LeafBuildingState(StorableConstructorFlag _) : base(_) { }
+      protected LeafBuildingState(LeafBuildingState original, Cloner cloner) : base(original, cloner) {
+        nodeQueue = new Queue<RegressionNodeModel>(original.nodeQueue.Select(cloner.Clone));
+        trainingRowsQueue = new Queue<IReadOnlyList<int>>(original.trainingRowsQueue.Select(x => (IReadOnlyList<int>)x.ToArray()));
+        Code = original.Code;
+      }
+      public LeafBuildingState() { }
+      public override IDeepCloneable Clone(Cloner cloner) {
+        return new LeafBuildingState(this, cloner);
+      }
+      #endregion
+
+      public void FillLeafs(RegressionNodeTreeModel tree, IReadOnlyList<int> trainingRows, IDataset data) {
+        var helperQueue = new Queue<RegressionNodeModel>();
+        var trainingHelperQueue = new Queue<IReadOnlyList<int>>();
+        nodeQueue.Clear();
+        trainingRowsQueue.Clear();
+
+        helperQueue.Enqueue(tree.Root);
+        trainingHelperQueue.Enqueue(trainingRows);
+
+        while (helperQueue.Count != 0) {
+          var n = helperQueue.Dequeue();
+          var t = trainingHelperQueue.Dequeue();
+          if (n.IsLeaf) {
+            nodeQueue.Enqueue(n);
+            trainingRowsQueue.Enqueue(t);
+            continue;
+          }
+
+          IReadOnlyList<int> leftTraining, rightTraining;
+          RegressionTreeUtilities.SplitRows(t, data, n.SplitAttribute, n.SplitValue, out leftTraining, out rightTraining);
+
+          helperQueue.Enqueue(n.Left);
+          helperQueue.Enqueue(n.Right);
+          trainingHelperQueue.Enqueue(leftTraining);
+          trainingHelperQueue.Enqueue(rightTraining);
+        }
+      }
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LinearLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LinearLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/LinearLeaf.cs	(revision 16892)
@@ -0,0 +1,61 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("347CA25D-FB37-4C4F-9B61-9D79288B2B28")]
+  [Item("LinearLeaf", "A leaf type that uses linear models as leaf models. This is the standard for M5' regression")]
+  public class LinearLeaf : LeafBase {
+    #region Constructors & Cloning
+    [StorableConstructor]
+    protected LinearLeaf(StorableConstructorFlag _) : base(_) { }
+    protected LinearLeaf(LinearLeaf original, Cloner cloner) : base(original, cloner) { }
+    public LinearLeaf() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new LinearLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return true; }
+    }
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters) {
+      if (pd.Dataset.Rows < MinLeafSize(pd)) throw new ArgumentException("The number of training instances is too small to create a linear model");
+      double rmse, cvRmse;
+      numberOfParameters = pd.AllowedInputVariables.Count() + 1;
+      var res = LinearRegression.CreateSolution(pd, out rmse, out cvRmse);
+      return res.Model;
+    }
+
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return pd.AllowedInputVariables.Count() == 1 ? 2 : pd.AllowedInputVariables.Count() + 2;
+    }
+    #endregion
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5Leaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5Leaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5Leaf.cs	(revision 16892)
@@ -0,0 +1,198 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("58517042-5318-4087-B098-AC75F0208BA0")]
+  [Item("M5Leaf", "A leaf type that uses regularized linear models with feature selection as leaf models.")]
+  public sealed class M5Leaf : LeafBase {
+    #region Constructors & Cloning
+    [StorableConstructor]
+    private M5Leaf(StorableConstructorFlag _) : base(_) { }
+    private M5Leaf(M5Leaf original, Cloner cloner) : base(original, cloner) { }
+    public M5Leaf() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new M5Leaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return false; }
+    }
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters) {
+      if (pd.Dataset.Rows == 0) throw new ArgumentException("The number of training instances is too small to create an M5 leaf model");
+
+      if (pd.Dataset.Rows == 1)
+        return new ConstantLeaf().Build(pd, random, cancellationToken, out numberOfParameters);
+
+      var means = pd.AllowedInputVariables.ToDictionary(n => n, n => pd.Dataset.GetDoubleValues(n, pd.TrainingIndices).Average());
+      var variances = pd.AllowedInputVariables.ToDictionary(n => n, n => pd.Dataset.GetDoubleValues(n, pd.TrainingIndices).Variance());
+      var used = pd.AllowedInputVariables.Where(v => !variances[v].IsAlmost(0.0)).ToList();
+
+      var targetMean = pd.TargetVariableTrainingValues.Average();
+      var targetVariance = pd.TargetVariableTrainingValues.Variance();
+
+      var model = FindBestModel(variances, means, targetMean, targetVariance, pd, used);
+      numberOfParameters = 1 + model.Coefficients.Count;
+      return model;
+    }
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return 1;
+    }
+    #endregion
+
+    private static PreconstructedLinearModel FindBestModel(Dictionary<string, double> variances, Dictionary<string, double> means, double yMean, double yVariance, IRegressionProblemData pd, IList<string> variables) {
+      Dictionary<string, double> coeffs;
+      double intercept;
+      do {
+        coeffs = DoRegression(pd, variables, variances, means, yMean, 1.0e-8, out intercept);
+        variables = DeselectColinear(variances, coeffs, yVariance, pd, variables);
+      }
+      while (coeffs.Count != variables.Count);
+      var numAtts = variables.Count;
+      var numInst = pd.TrainingIndices.Count();
+      var fullMse = CalculateSE(coeffs, intercept, pd, variables);
+      var akaike = 1.0 * (numInst - numAtts) + 2 * numAtts;
+
+      var improved = true;
+      var currentNumAttributes = numAtts;
+
+      while (improved && currentNumAttributes > 1) {
+        improved = false;
+        currentNumAttributes--;
+        // Find attribute with smallest SC (variance-scaled coefficient)
+        var candidate = variables.ToDictionary(v => v, v => Math.Abs(coeffs[v] * Math.Sqrt(variances[v] / yVariance)))
+          .OrderBy(x => x.Value).Select(x => x.Key).First();
+
+        var currVariables = variables.Where(v => !v.Equals(candidate)).ToList();
+        var currentIntercept = 0.0;
+        var currentCoeffs = DoRegression(pd, currVariables, variances, means, yMean, 1.0e-8, out currentIntercept);
+        var currentMse = CalculateSE(currentCoeffs, currentIntercept, pd, currVariables);
+        var currentAkaike = currentMse / fullMse * (numInst - numAtts) + 2 * currentNumAttributes;
+
+        if (!(currentAkaike < akaike)) continue;
+        improved = true;
+        akaike = currentAkaike;
+        coeffs = currentCoeffs;
+        intercept = currentIntercept;
+        variables = currVariables;
+      }
+
+      var pd2 = new RegressionProblemData(pd.Dataset, variables, pd.TargetVariable);
+      pd2.TestPartition.End = pd.TestPartition.End;
+      pd2.TestPartition.Start = pd.TestPartition.Start;
+      pd2.TrainingPartition.End = pd.TrainingPartition.End;
+      pd2.TrainingPartition.Start = pd.TrainingPartition.Start;
+
+      return new PreconstructedLinearModel(coeffs, intercept, pd.TargetVariable);
+    }
+
+    private static Dictionary<string, double> DoRegression(IRegressionProblemData pd, IList<string> variables, Dictionary<string, double> variances, Dictionary<string, double> means, double yMean, double ridge, out double intercept) {
+
+      var n = variables.Count;
+      var m = pd.TrainingIndices.Count();
+
+      var inTr = new double[n, m];
+      for (var i = 0; i < n; i++) {
+        var v = variables[i];
+        var vdata = pd.Dataset.GetDoubleValues(v, pd.TrainingIndices).ToArray();
+        var sd = Math.Sqrt(variances[v]);
+        var mean = means[v];
+        for (var j = 0; j < m; j++) {
+          inTr[i, j] = (vdata[j] - mean) / sd;
+        }
+      }
+
+      var y = new double[m, 1];
+      var ydata = pd.TargetVariableTrainingValues.ToArray();
+      for (var i = 0; i < m; i++)
+        y[i, 0] = ydata[i]; //no scaling for targets;
+
+
+      var aTy = new double[n, 1];
+      alglib.rmatrixgemm(n, 1, m, 1, inTr, 0, 0, 0, y, 0, 0, 0, 0, ref aTy, 0, 0); //aTy = inTr * y;
+      var aTa = new double[n, n];
+      alglib.rmatrixgemm(n, n, m, 1, inTr, 0, 0, 0, inTr, 0, 0, 1, 0, ref aTa, 0, 0); //aTa = inTr * t(inTr) +aTa //
+
+      var aTaDecomp = new double[n, n];
+      bool success;
+      var tries = 0;
+      double[] coefficients = null;
+      do {
+        for (var i = 0; i < n; i++) aTa[i, i] += ridge; // add ridge to diagonal to enforce singularity
+        try {
+          //solve "aTa * coefficients = aTy" for coefficients;
+          Array.Copy(aTa, 0, aTaDecomp, 0, aTa.Length);
+          alglib.spdmatrixcholesky(ref aTaDecomp, n, true);
+          int info;
+          alglib.densesolverreport report;
+          alglib.spdmatrixcholeskysolve(aTaDecomp, n, true, ydata, out info, out report, out coefficients);
+
+          if (info != 1) throw new Exception();
+          success = true;
+        }
+        catch (Exception) {
+          for (var i = 0; i < n; i++) aTa[i, i] -= ridge;
+          ridge *= 10; // increase ridge;
+          success = false;
+        }
+        finally {
+          tries++;
+        }
+      }
+      while (!success && tries < 100);
+      if (coefficients == null || coefficients.Length != n) throw new ArgumentException("No linear model could be built");
+
+      intercept = yMean;
+      var res = new Dictionary<string, double>();
+      for (var i = 0; i < n; i++) {
+        var v = variables[i];
+        res.Add(v, coefficients[i] /= Math.Sqrt(variances[v]));
+        intercept -= coefficients[i] * means[v];
+      }
+
+      return res;
+    }
+
+    private static IList<string> DeselectColinear(Dictionary<string, double> variances, Dictionary<string, double> coeffs, double yVariance, IRegressionProblemData pd, IList<string> variables) {
+      var candidates = variables.ToDictionary(v => v, v => Math.Abs(coeffs[v] * Math.Sqrt(variances[v] / yVariance))).Where(x => x.Value > 1.5).OrderBy(x => -x.Value).ToList();
+      if (candidates.Count == 0) return variables;
+      var c = candidates.First().Key;
+      return variables.Where(v => !v.Equals(c)).ToList();
+    }
+
+    private static double CalculateSE(Dictionary<string, double> coefficients, double intercept, IRegressionProblemData pd, IList<string> variables) {
+      return pd.TrainingIndices.Select(i => RegressionPrediction(i, pd, variables, coefficients, intercept) - pd.Dataset.GetDoubleValue(pd.TargetVariable, i)).Select(error => error * error).Sum();
+    }
+    private static double RegressionPrediction(int i, IRegressionProblemData pd, IList<string> variables, Dictionary<string, double> coefficients, double intercept) {
+      return intercept + variables.Sum(v => pd.Dataset.GetDoubleValue(v, i) * coefficients[v]);
+    }
+  }
+}
Index: /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5regLeaf.cs
===================================================================
--- /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5regLeaf.cs	(revision 16892)
+++ /branches/2925_AutoDiffForDynamicalModels/HeuristicLab.Algorithms.DataAnalysis.M5/3.4/LeafTypes/M5regLeaf.cs	(revision 16892)
@@ -0,0 +1,64 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2017 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Linq;
+using System.Threading;
+using HeuristicLab.Algorithms.DataAnalysis.Glmnet;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Problems.DataAnalysis;
+using HEAL.Attic;
+
+namespace HeuristicLab.Algorithms.DataAnalysis {
+  [StorableType("0AED959D-78C3-4927-BDCF-473D0AEE32AA")]
+  [Item("M5regLeaf", "A leaf type that uses regularized linear models as leaf models.")]
+  public sealed class M5regLeaf : LeafBase {
+    #region Constructors & Cloning
+    [StorableConstructor]
+    private M5regLeaf(StorableConstructorFlag _) : base(_) { }
+    private M5regLeaf(M5regLeaf original, Cloner cloner) : base(original, cloner) { }
+    public M5regLeaf() { }
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new M5regLeaf(this, cloner);
+    }
+    #endregion
+
+    #region IModelType
+    public override bool ProvidesConfidence {
+      get { return false; }
+    }
+
+    public override IRegressionModel Build(IRegressionProblemData pd, IRandom random, CancellationToken cancellationToken, out int numberOfParameters) {
+      if (pd.Dataset.Rows < MinLeafSize(pd)) throw new ArgumentException("The number of training instances is too small to create a linear model");
+      numberOfParameters = pd.AllowedInputVariables.Count() + 1;
+
+      double x1, x2;
+      var coeffs = ElasticNetLinearRegression.CalculateModelCoefficients(pd, 1, 0.2, out x1, out x2);
+      numberOfParameters = coeffs.Length;
+      return ElasticNetLinearRegression.CreateSymbolicSolution(coeffs, pd).Model;
+    }
+    public override int MinLeafSize(IRegressionProblemData pd) {
+      return pd.AllowedInputVariables.Count() + 2;
+    }
+    #endregion
+  }
+}
